package cn.com.infosec.jce.spec;

import cn.com.infosec.crypto.engines.GOST28147Engine;
import java.security.spec.AlgorithmParameterSpec;

public class GOST28147ParameterSpec implements AlgorithmParameterSpec {
   private byte[] iv;
   private byte[] sBox;

   public GOST28147ParameterSpec(byte[] sBox) {
      byte[] var10000 = sBox;
      super();
      this.iv = null;
      this.sBox = null;
      byte[] var2;
      this.sBox = var2 = new byte[sBox.length];
      int sBox1 = sBox.length;
      System.arraycopy(var10000, 0, var2, 0, sBox1);
   }

   public GOST28147ParameterSpec(byte[] sBox, byte[] iv) {
      this(sBox);
      byte[] var3;
      this.iv = var3 = new byte[iv.length];
      int sBox1 = iv.length;
      System.arraycopy(iv, 0, var3, 0, sBox1);
   }

   public GOST28147ParameterSpec(String sBoxName) {
      this.iv = null;
      this.sBox = null;
      this.sBox = GOST28147Engine.getSBox(sBoxName);
   }

   public GOST28147ParameterSpec(String sBoxName, byte[] iv) {
      this(sBoxName);
      byte[] var3;
      this.iv = var3 = new byte[iv.length];
      int sBoxName1 = iv.length;
      System.arraycopy(iv, 0, var3, 0, sBoxName1);
   }

   public byte[] getSbox() {
      return this.sBox;
   }

   public byte[] getIV() {
      byte[] var3;
      if ((var3 = this.iv) == null) {
         return null;
      } else {
         int var1;
         byte[] var2;
         byte[] var10000 = var2 = new byte[var1 = var3.length];
         System.arraycopy(var3, 0, var2, 0, var1);
         return var10000;
      }
   }
}
